use AllNasdaqTickerPricesfrom2014into2017
go

-- create table for storing raw csv file contents
begin try
DROP TABLE dbo.daily_temps_from_1_Jan_14_thru_8_Nov_17
end try
begin catch
print 'daily_temps_from_1_Jan_14_thru_8_Nov_17 not available to drop'
end catch

CREATE TABLE [dbo].[daily_temps_from_1_Jan_14_thru_8_Nov_17](
	[STATION] [varchar](20) NULL,
	[LATITUDE] [varchar](10) NULL,
	[LONGITUDE] [varchar](10) NULL,
	[ELEVATION] [varchar](10) NULL,
	[DATE] [varchar](10) NULL,
	[TAVG] [varchar](5) NULL,
	[TMAX] [varchar](5) NULL,
	[TMIN] [varchar](25) NULL
) ON [PRIMARY]

GO



-- enable the xp_cmdshell stored procedure
-- to copy csv file to SQL Server table
EXEC sp_configure 'xp_cmdshell', 1
RECONFIGURE

-- import a csv file with char, varchar, and text columns
DECLARE @cmd varchar(500)
SET @cmd = 'bcp AllNasdaqTickerPricesfrom2014into2017.dbo.daily_temps_from_1_Jan_14_thru_8_Nov_17 in ' +
'C:\temps_for_mining\ncdc_noaa_gov_daily_temps_from_1_Jan_14_thru_8_Nov_17.csv -c -T -t, -E'


EXEC master..xp_cmdshell @cmd

-- disable the xp_cmdshell stored procedure
EXEC sp_configure 'xp_cmdshell', 0
RECONFIGURE
GO


begin try
drop table AllNasdaqTickerPricesfrom2014into2017.dbo.daily_temps_from_1_Jan_14_thru_8_Nov_17_casted
end try
begin catch
print 'daily_temps_from_1_Jan_14_thru_8_Nov_17_casted is not available to drop'
end catch

SELECT
	[STATION],
	cast([LATITUDE] as real) [latitude],
	cast([LONGITUDE] as real) [longitude],
	cast([ELEVATION] as real) [elevation],
	cast([DATE] as [date]) [date],
	cast([TAVG] as real) [tavg],
	cast([TMAX] as real) [tmax],
	cast([TMIN] as real) [tmin]
into AllNasdaqTickerPricesfrom2014into2017.dbo.daily_temps_from_1_Jan_14_thru_8_Nov_17_casted
FROM AllNasdaqTickerPricesfrom2014into2017.dbo.daily_temps_from_1_Jan_14_thru_8_Nov_17
where [date] != 'DATE'

